<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.7"/>
<title>TI  Graph Library   (TIGL): Miscellenous</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">TI  Graph Library   (TIGL)
   &#160;<span id="projectnumber">ver1.00.00</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.7 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
</div><!-- top -->
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Groups</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Pages</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle">
<div class="title">Miscellenous</div>  </div>
</div><!--header-->
<div class="contents">

<p>Miscellenous profiling and general purpose functions.  
<a href="#details">More...</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:ga772a5f1377d8c6b66ab70f511e3dfc52"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ga772a5f1377d8c6b66ab70f511e3dfc52"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__misc__tools.html#ga772a5f1377d8c6b66ab70f511e3dfc52">tiglUtilsAvailableMemory</a> ()</td></tr>
<tr class="memdesc:ga772a5f1377d8c6b66ab70f511e3dfc52"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the approximate available memory in MB. <br /></td></tr>
<tr class="separator:ga772a5f1377d8c6b66ab70f511e3dfc52"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga02066628879346c4b2f5b73a26af0b76"><td class="memTemplParams" colspan="2">template&lt;typename VertexClass &gt; </td></tr>
<tr class="memitem:ga02066628879346c4b2f5b73a26af0b76"><td class="memTemplItemLeft" align="right" valign="top">bool&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="group__misc__tools.html#ga02066628879346c4b2f5b73a26af0b76">tiglUtilsCheckSymmetry</a> (vector&lt; VertexClass &gt; &amp;verticesList)</td></tr>
<tr class="memdesc:ga02066628879346c4b2f5b73a26af0b76"><td class="mdescLeft">&#160;</td><td class="mdescRight">Checks consistency of undirected graphs.  <a href="#ga02066628879346c4b2f5b73a26af0b76">More...</a><br /></td></tr>
<tr class="separator:ga02066628879346c4b2f5b73a26af0b76"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gad9ad5fa3dfd4dbebd3acc668c66b4ee5"><td class="memTemplParams" colspan="2">template&lt;typename VertexClass &gt; </td></tr>
<tr class="memitem:gad9ad5fa3dfd4dbebd3acc668c66b4ee5"><td class="memTemplItemLeft" align="right" valign="top">unsigned long&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="group__misc__tools.html#gad9ad5fa3dfd4dbebd3acc668c66b4ee5">tiglUtilsCountEdges</a> (vector&lt; VertexClass &gt; &amp;vertexList, typename VertexClass::ID_TYPE startSrcID, typename VertexClass::ID_TYPE endSrcID, typename VertexClass::ID_TYPE startDstID, typename VertexClass::ID_TYPE endDstID)</td></tr>
<tr class="memdesc:gad9ad5fa3dfd4dbebd3acc668c66b4ee5"><td class="mdescLeft">&#160;</td><td class="mdescRight">Counts all the edges of between a subset of vertices.  <a href="#gad9ad5fa3dfd4dbebd3acc668c66b4ee5">More...</a><br /></td></tr>
<tr class="separator:gad9ad5fa3dfd4dbebd3acc668c66b4ee5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga9cfa46787ac0a4b0d0240463748b537e"><td class="memTemplParams" colspan="2">template&lt;typename VertexClass &gt; </td></tr>
<tr class="memitem:ga9cfa46787ac0a4b0d0240463748b537e"><td class="memTemplItemLeft" align="right" valign="top">unsigned long&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="group__misc__tools.html#ga9cfa46787ac0a4b0d0240463748b537e">tiglUtilsCountEdges</a> (vector&lt; VertexClass &gt; &amp;vertexList)</td></tr>
<tr class="memdesc:ga9cfa46787ac0a4b0d0240463748b537e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Counts all the edges in a graph.  <a href="#ga9cfa46787ac0a4b0d0240463748b537e">More...</a><br /></td></tr>
<tr class="separator:ga9cfa46787ac0a4b0d0240463748b537e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga141c5392ab4103862d53e61f2b65c466"><td class="memTemplParams" colspan="2">template&lt;typename VERTEX_ITERATOR , typename ID_TYPE &gt; </td></tr>
<tr class="memitem:ga141c5392ab4103862d53e61f2b65c466"><td class="memTemplItemLeft" align="right" valign="top">unsigned long&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="group__misc__tools.html#ga141c5392ab4103862d53e61f2b65c466">tiglUtilsCountEdges</a> (VERTEX_ITERATOR itStart, VERTEX_ITERATOR itEnd, ID_TYPE startSrcID, ID_TYPE endSrcID, ID_TYPE startDstID, ID_TYPE endDstID)</td></tr>
<tr class="memdesc:ga141c5392ab4103862d53e61f2b65c466"><td class="mdescLeft">&#160;</td><td class="mdescRight">Overloaded version of counting edges using iterators.  <a href="#ga141c5392ab4103862d53e61f2b65c466">More...</a><br /></td></tr>
<tr class="separator:ga141c5392ab4103862d53e61f2b65c466"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gabc4f73f9c569080abea99832e65f2248"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__misc__tools.html#gabc4f73f9c569080abea99832e65f2248">tiglUtilsGenUrandom</a> (double *buf, unsigned long numEntries)</td></tr>
<tr class="memdesc:gabc4f73f9c569080abea99832e65f2248"><td class="mdescLeft">&#160;</td><td class="mdescRight">Generates random variable(s) that is uniformly distributed between [0, 1].  <a href="#gabc4f73f9c569080abea99832e65f2248">More...</a><br /></td></tr>
<tr class="separator:gabc4f73f9c569080abea99832e65f2248"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga2befdfe64cd356073493c2b7f0faf34d"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ga2befdfe64cd356073493c2b7f0faf34d"></a>
double&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__misc__tools.html#ga2befdfe64cd356073493c2b7f0faf34d">tiglUtilsGetTimeUs</a> ()</td></tr>
<tr class="memdesc:ga2befdfe64cd356073493c2b7f0faf34d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the absolute reference time in us. <br /></td></tr>
<tr class="separator:ga2befdfe64cd356073493c2b7f0faf34d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga12da4cca047aa79efda31868674fd69a"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ga12da4cca047aa79efda31868674fd69a"></a>
int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__misc__tools.html#ga12da4cca047aa79efda31868674fd69a">MPI_BARRIER</a> ()</td></tr>
<tr class="memdesc:ga12da4cca047aa79efda31868674fd69a"><td class="mdescLeft">&#160;</td><td class="mdescRight">Overriden MPI barrier function. <br /></td></tr>
<tr class="separator:ga12da4cca047aa79efda31868674fd69a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gaba06990768c6b572ca3f69029334a9df"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="gaba06990768c6b572ca3f69029334a9df"></a>
int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__misc__tools.html#gaba06990768c6b572ca3f69029334a9df">omp_get_thread_num</a> ()</td></tr>
<tr class="memdesc:gaba06990768c6b572ca3f69029334a9df"><td class="mdescLeft">&#160;</td><td class="mdescRight">Overridden openMP routines. <br /></td></tr>
<tr class="separator:gaba06990768c6b572ca3f69029334a9df"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga0ba8419685cb5738bbe07568e82eec4e"><td class="memItemLeft" align="right" valign="top">uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__misc__tools.html#ga0ba8419685cb5738bbe07568e82eec4e">tiglUtilsRegisterTime</a> ()</td></tr>
<tr class="memdesc:ga0ba8419685cb5738bbe07568e82eec4e"><td class="mdescLeft">&#160;</td><td class="mdescRight">returns the time in ns from the last call.  <a href="#ga0ba8419685cb5738bbe07568e82eec4e">More...</a><br /></td></tr>
<tr class="separator:ga0ba8419685cb5738bbe07568e82eec4e"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<p>Miscellenous profiling and general purpose functions. </p>
<h2 class="groupheader">Function Documentation</h2>
<a class="anchor" id="ga02066628879346c4b2f5b73a26af0b76"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename VertexClass &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">bool tiglUtilsCheckSymmetry </td>
          <td>(</td>
          <td class="paramtype">vector&lt; VertexClass &gt; &amp;&#160;</td>
          <td class="paramname"><em>verticesList</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Checks consistency of undirected graphs. </p>
<dl class="section return"><dt>Returns</dt><dd>true if conistent, false otherwise </dd></dl>

</div>
</div>
<a class="anchor" id="gad9ad5fa3dfd4dbebd3acc668c66b4ee5"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename VertexClass &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">unsigned long tiglUtilsCountEdges </td>
          <td>(</td>
          <td class="paramtype">vector&lt; VertexClass &gt; &amp;&#160;</td>
          <td class="paramname"><em>vertexList</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">typename VertexClass::ID_TYPE&#160;</td>
          <td class="paramname"><em>startSrcID</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">typename VertexClass::ID_TYPE&#160;</td>
          <td class="paramname"><em>endSrcID</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">typename VertexClass::ID_TYPE&#160;</td>
          <td class="paramname"><em>startDstID</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">typename VertexClass::ID_TYPE&#160;</td>
          <td class="paramname"><em>endDstID</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Counts all the edges of between a subset of vertices. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">vertexList</td><td>list of vertices </td></tr>
    <tr><td class="paramname">startSrcID</td><td>starting ID of source vertices </td></tr>
    <tr><td class="paramname">endSrcID</td><td>end ID of source vertices </td></tr>
    <tr><td class="paramname">startDstID</td><td>starting ID of target vertices </td></tr>
    <tr><td class="paramname">endDstID</td><td>end ID of target vertices</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>The number of edges originating from any of the source vertices within range to any of destination vertices within range </dd></dl>

</div>
</div>
<a class="anchor" id="ga9cfa46787ac0a4b0d0240463748b537e"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename VertexClass &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">unsigned long tiglUtilsCountEdges </td>
          <td>(</td>
          <td class="paramtype">vector&lt; VertexClass &gt; &amp;&#160;</td>
          <td class="paramname"><em>vertexList</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Counts all the edges in a graph. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">vertexList</td><td>list of vertices</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>The total number of edges in the graph </dd></dl>

</div>
</div>
<a class="anchor" id="ga141c5392ab4103862d53e61f2b65c466"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename VERTEX_ITERATOR , typename ID_TYPE &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">unsigned long tiglUtilsCountEdges </td>
          <td>(</td>
          <td class="paramtype">VERTEX_ITERATOR&#160;</td>
          <td class="paramname"><em>itStart</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">VERTEX_ITERATOR&#160;</td>
          <td class="paramname"><em>itEnd</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">ID_TYPE&#160;</td>
          <td class="paramname"><em>startSrcID</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">ID_TYPE&#160;</td>
          <td class="paramname"><em>endSrcID</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">ID_TYPE&#160;</td>
          <td class="paramname"><em>startDstID</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">ID_TYPE&#160;</td>
          <td class="paramname"><em>endDstID</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Overloaded version of counting edges using iterators. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">itStart</td><td>start iterator of the vertex list </td></tr>
    <tr><td class="paramname">itEnd</td><td>end iterator of the vertex list </td></tr>
    <tr><td class="paramname">startSrcID</td><td>starting ID of source vertices </td></tr>
    <tr><td class="paramname">endSrcID</td><td>end ID of source vertices </td></tr>
    <tr><td class="paramname">startDstID</td><td>starting ID of target vertices </td></tr>
    <tr><td class="paramname">endDstID</td><td>end ID of target vertices</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>The number of edges originating from any of the source vertices within range to any of destination vertices within range </dd></dl>

</div>
</div>
<a class="anchor" id="gabc4f73f9c569080abea99832e65f2248"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void tiglUtilsGenUrandom </td>
          <td>(</td>
          <td class="paramtype">double *&#160;</td>
          <td class="paramname"><em>buf</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned long&#160;</td>
          <td class="paramname"><em>numEntries</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Generates random variable(s) that is uniformly distributed between [0, 1]. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">buf</td><td>output buffer </td></tr>
    <tr><td class="paramname">numEntries</td><td>number of generated random variables </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ga0ba8419685cb5738bbe07568e82eec4e"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">uint_fast32_t tiglUtilsRegisterTime </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>returns the time in ns from the last call. </p>
<dl class="section warning"><dt>Warning</dt><dd>the very first call returns undefined value </dd></dl>

</div>
</div>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Thu Jun 25 2015 11:13:52 for TI  Graph Library   (TIGL) by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.7
</small></address>
</body>
</html>
